unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnAccettaDimensione: TButton;
    BtnCreaConDatiRandom: TButton;
    BtnCreaOrdinato: TButton;
    BtnCreaConDatiUtente: TButton;
    BtnInizializza: TButton;
    BtnInserimento: TButton;
    BtnMedia: TButton;
    BtnPulisci: TButton;
    BtnStampa: TButton;
    BtnModifica: TButton;
    BtnStampaCompleta: TButton;
    BtnOccorrenze: TButton;
    BtnMinimoMassimo: TButton;
    BtnOrdinaCrescente: TButton;
    BtnOrdinaDecrescent: TButton;
    BtnDisordina: TButton;
    BtnRicercaCompleta: TButton;
    BtnRicercaSeriale: TButton;
    BtnRicercaSequenziale: TButton;
    BtnRicercaBinaria: TButton;
    BtnCancellazione: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox5: TListBox;
    ListBox4: TListBox;
    ListBox3: TListBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure BtnAccettaDimensioneClick(Sender: TObject);
    procedure BtnCancellazioneClick(Sender: TObject);
    procedure BtnCreaConDatiRandomClick(Sender: TObject);
    procedure BtnCreaConDatiUtenteClick(Sender: TObject);
    procedure BtnCreaOrdinatoClick(Sender: TObject);
    procedure BtnDisordinaClick(Sender: TObject);
    procedure BtnInizializzaClick(Sender: TObject);
    procedure BtnInserimentoClick(Sender: TObject);
    procedure BtnMediaClick(Sender: TObject);
    procedure BtnMinimoMassimoClick(Sender: TObject);
    procedure BtnModificaClick(Sender: TObject);
    procedure BtnOccorrenzeClick(Sender: TObject);
    procedure BtnOrdinaCrescenteClick(Sender: TObject);
    procedure BtnOrdinaDecrescentClick(Sender: TObject);
    procedure BtnPulisciClick(Sender: TObject);
    procedure BtnRicercaBinariaClick(Sender: TObject);
    procedure BtnRicercaCompletaClick(Sender: TObject);
    procedure BtnRicercaSequenzialeClick(Sender: TObject);
    procedure BtnRicercaSerialeClick(Sender: TObject);
    procedure BtnStampaClick(Sender: TObject);
    procedure BtnStampaCompletaClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure RadioButton3Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

Const MaxComp = 30 ;

Type TVet = array [1 .. MaxComp] of Integer ;
Var  Vet : TVet ;   DimVet : Integer ;      ListaStampa : 1 .. 3 ;    // variabile di tipo subrange

Procedure Inizializza(Var V : TVet; Var DimV : Integer);
Var i : Integer ;
begin
  For i := 1 To MaxComp do V[i] := 0 ;
  DimV := 0 ;
end;

Procedure StampaCompleta(V : TVet; DimV : Integer) ;
Var i : Integer;
begin
  Form1.ListBox1.Clear ;
  For i := 1 To MaxComp do Form1.ListBox1.Items.Add(IntToStr(V[i])) ;
end;

Procedure AccettaDimensione(V : TVet; Var DimV : Integer) ;
begin
  Repeat
    DimV := StrToInt(Inputbox('','Inserisci dimensione','')) ;
  Until (DimV >= 0) And (DimV <= MaxComp)
end;

Procedure Stampa(V : TVet; DimV : Integer;  Lista : Integer) ;
Var i : Integer;
begin
  Case Lista of
    1 : begin
          Form1.ListBox1.Clear ;
          For i := 1 To DimV do Form1.ListBox1.Items.Add(IntToStr(V[i])) ;
        end;
    2 : begin
          Form1.ListBox2.Clear ;
          For i := 1 To dimV do Form1.ListBox2.Items.Add(IntToStr(V[i])) ;
        end;
    3 : begin
          Form1.ListBox3.Clear ;
          For i := 1 To dimV do Form1.ListBox3.Items.Add(IntToStr(V[i])) ;
        end;
  end;
end;

Procedure CreaConDatiRandom(Var V : TVet; DimV : Integer) ;
Var i : Integer ;
begin
  For i := 1 To DimV do V[i] := Random(90) + 1  ;
end;

Procedure CreaConDatiUtente(Var V : TVet; DimV : Integer) ;
Var i : Integer ;
begin
  For i := 1 To DimV do
    V[i] := StrToInt(Inputbox('','Inserisci la componente di posto ' + IntToStr(i),'')) ;
end;

Procedure CreaOrdinato(Var V : TVet; DimV : Integer) ;
Var i : Integer ;
begin
  V[1] := Random(10) ;
  For i := 2 To DimV do V[i] := V[i - 1] + Random(5) + 1  ;
end;

Procedure OrdinaCrescente(Var V : TVet; DimV : Integer) ;
Var i, j : Integer ;  Temp : Integer ;
begin
  For i := 1 To DimV - 1 do
    For j := i + 1 To DimV do
      If V[i] > V[j] Then
        begin
          Temp := V[i] ;
          V[i] := V[j] ;
          V[j] := Temp ;
        end;
end;

Procedure OrdinaDeCrescente(Var V : TVet; DimV : Integer) ;
Var i, j : Integer ;  Temp : Integer ;
begin
  For i := 1 To DimV - 1 do
    For j := i + 1 To DimV do
      If V[i] < V[j] Then
        begin
          Temp := V[i] ;
          V[i] := V[j] ;
          V[j] := Temp ;
        end;
end;

Procedure Disordina(Var V : TVet; DimV : Integer) ;
Var i, j : Integer ;  Temp : Integer ;
begin
  For i := 1 To DimV do
    begin
       j := Random(DimV) + 1 ;
       Temp := V[i] ;
       V[i] := v[j] ;
       v[j] := Temp ;
    end;
end;

Function RicercaSeriale (V: TVet; DimV: Integer; Valore: Integer): Integer ;
Var i, Pos : Integer ;
begin
  Pos := 0 ;
  For i := 1 To DimV do
    If V[i] = Valore Then Pos := i ;
  RicercaSeriale := Pos ;
end;

Function RicercaCompleta(V: TVet; DimV: Integer; Valore: Integer): Integer ;
Var i, Pos : Integer ;
begin
  Pos := 0 ;
  i := 1 ;
  While (i <= DimV) And (Pos = 0) do
    begin
      If V[i] = Valore Then Pos := i
      Else i := i + 1
    end;
  RicercaCompleta := Pos ;
end;

Function RicercaSequenziale(V: TVet; DimV: Integer; Valore: Integer): Integer ;
Var i, Pos : Integer ;
begin
  Pos := 0 ;
  i := 1 ;
  While (i <= DimV) And (Pos = 0) And (V[i] <= Valore) do
    begin
      If V[i] = Valore Then Pos := i
      Else i := i + 1
    end;
  RicercaSequenziale := Pos ;
end;

Function RicercaBinaria(V: TVet; DimV: Integer; Valore: Integer): Integer ;
Var i, j, Pos, Medio : Integer ;
begin
  i := 1 ;
  j := DimV ;
  Pos := 0 ;
  While (Pos = 0) And (i <= j) do
    begin
      Medio := (i + j) div 2 ;
      If Valore = V[Medio] Then Pos := Medio
      Else
        If Valore < V[Medio] Then j := Medio - 1
        Else i := Medio + 1
    end;
 RicercaBinaria := Pos ;
end;

Procedure Inserimento(Var V: TVet; Var DimV: Integer; Valore: Integer; Var Verif: Boolean) ;
begin
  if DimV < MaxComp then
    begin
      DimV := DimV + 1 ;
      V[DimV] := Valore ;
      Verif := true ;
    end
  else Verif := false ;
end;

procedure Modifica(Var V: TVet; DimV: Integer; NuovoV, VecchioV: Integer; Var Verif: Boolean) ;
Var Posizione : Integer ;
begin
  Posizione := RicercaCompleta (V, DimV, VecchioV) ;
  If Posizione > 0 Then
    begin
      V[Posizione] := NuovoV ;
      Verif := true ;
    end
  else
    Verif := false ;
end;

procedure Cancellazione(Var V: TVet; Var DimV: Integer; Valore: Integer; Var Verif: Boolean) ;
Var Posizione : Integer ;
begin
  Posizione := RicercaCompleta (V, DimV, Valore) ;
  If Posizione > 0 Then
    begin
      V[Posizione] := V[DimV]  ;
      DimV := DimV - 1 ;
      Verif := true ;
    end
  else Verif := false ;
end;

function Media(V: TVet; DimV: Integer) : Single ;
Var Somma, i : Integer ;
begin
  Media := 0  ;
  Somma := 0  ;
  For i := 1 To DimV do Somma := Somma + V[i] ;
  Media := Somma / DimV  ;
end;

Procedure MinimoMassimo(V: TVet; DimV: Integer; Var Min, Max : Integer) ;
Var i : Integer ;
begin
  Min := V[1] ;
  Max := V[1] ;
  For i := 1 To DimV do
    begin
      If V[i] > Max Then Max := V[i] ;
      If V[i] < Min Then Min := V[i] ;
      end ;
end;

function Occorrenze(V: TVet; DimV: Integer; Valore: Integer) : Integer ;
Var Volte, i : Integer ;
begin
  Volte := 0 ;
  For i := 1 To DimV do
    If V[i] = Valore Then Volte := Volte + 1 ;
  Occorrenze := Volte ;
end;

procedure TForm1.BtnRicercaSerialeClick(Sender: TObject);
Var ValoreDaCercare, Posizione : Integer ;
begin
  ValoreDaCercare := StrToInt(Inputbox('','Inserisci il valore da cercare','')) ;
  Posizione := RicercaCompleta (Vet, DimVet, ValoreDaCercare);
  If Posizione > 0 Then
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' esiste in posizione ' + IntToStr(Posizione))
  Else
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' non esiste.  ') ;
end;

procedure TForm1.BtnRicercaCompletaClick(Sender: TObject);
Var ValoreDaCercare, Posizione : Integer ;
begin
  ValoreDaCercare := StrToInt(Inputbox('','Inserisci il valore da cercare','')) ;
  Posizione := RicercaCompleta (Vet, DimVet, ValoreDaCercare);
  If Posizione > 0 Then
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' esiste in posizione ' + IntToStr(Posizione))
  Else
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' non esiste.  ') ;
end;

procedure TForm1.BtnRicercaSequenzialeClick(Sender: TObject);
Var ValoreDaCercare, Posizione : Integer ;
begin
  ValoreDaCercare := StrToInt(Inputbox('','Inserisci il valore da cercare','')) ;
  Posizione := RicercaSequenziale (Vet, DimVet, ValoreDaCercare);
  If Posizione > 0 Then
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' esiste in posizione ' + IntToStr(Posizione))
  Else
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' non esiste.  ') ;
end;

procedure TForm1.BtnRicercaBinariaClick(Sender: TObject);
Var ValoreDaCercare, Posizione : Integer ;
begin
  ValoreDaCercare := StrToInt(Inputbox('','Inserisci il valore da cercare','')) ;
  Posizione := RicercaBinaria (Vet, DimVet, ValoreDaCercare);
  If Posizione > 0 Then
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' esiste in posizione ' + IntToStr(Posizione))
  Else
    ListBox5.Items.Add(IntToStr(ValoreDaCercare) + ' non esiste.  ') ;
end;

procedure TForm1.BtnModificaClick(Sender: TObject);
var Valore, NuovoValore : integer ;  Verifica : Boolean ;
begin
  Valore := StrToInt(Inputbox('','Inserisci il valore da modificare','')) ;
  NuovoValore := StrToInt(Inputbox('','Inserisci il nuovo valore','')) ;
  Modifica(Vet, DimVet, NuovoValore, Valore, Verifica) ;
  If Verifica = true                                         // anche solo   If Verifica then
    then Form1.ListBox5.Items.Add(IntToStr(Valore) + ' è stato modificato con ' + IntToStr(NuovoValore))
    else Form1.ListBox5.Items.Add(IntToStr(Valore) + ' non è stato modificato ') ;
end;

procedure TForm1.BtnStampaClick(Sender: TObject);
begin
  Stampa(Vet, DimVet, ListaStampa) ;
end;

procedure TForm1.BtnStampaCompletaClick(Sender: TObject);
begin
  StampaCompleta(Vet, DimVet) ;
end;

procedure TForm1.BtnInizializzaClick(Sender: TObject);
begin
  Inizializza(Vet, DimVet) ;
end;

procedure TForm1.BtnInserimentoClick(Sender: TObject);
Var ValoreDaInserire : Integer ;  Verifica : Boolean ;
begin
  ValoreDaInserire := StrToInt(Inputbox('','Inserisci il valore da aggiungere','')) ;
  Inserimento (Vet, DimVet, ValoreDaInserire, Verifica) ;
  if Verifica
    then ListBox5.Items.Add(IntToStr(ValoreDaInserire) + ' è stato aggiunto ')
    else ListBox5.Items.Add(IntToStr(ValoreDaInserire) + ' non è stato aggiunto ')
end;

procedure TForm1.BtnMediaClick(Sender: TObject);
Var M : Single ;
begin
  M := Media(Vet, DimVet) ;
  ListBox5.Items.Add('Media = ' + FloatToStrF(M,ffFixed,5,2)) ;
end;

procedure TForm1.BtnMinimoMassimoClick(Sender: TObject);
Var Minimo, Massimo : Integer ;
begin
  MinimoMassimo(Vet, DimVet, Minimo, Massimo) ;
  ListBox5.Items.Add('Minimo = ' + IntToStr(Minimo)) ;
  ListBox5.Items.Add('Massimo = ' + IntToStr(Massimo)) ;
end;

procedure TForm1.BtnOccorrenzeClick(Sender: TObject);
Var Valore : Integer ; NumeroOccorrenze : Integer ;

begin
  Valore := StrToInt(Inputbox('','Inserisci valore da cercare','')) ;
  NumeroOccorrenze := Occorrenze(Vet, DimVet, Valore) ;
  ListBox5.Items.Add(IntToStr(Valore) + ' è presente ' + IntToStr(NumeroOccorrenze) + ' volte ')
end;

procedure TForm1.BtnOrdinaCrescenteClick(Sender: TObject);
begin
  OrdinaCrescente(Vet, DimVet) ;
end;

procedure TForm1.BtnOrdinaDecrescentClick(Sender: TObject);
begin
  OrdinaDeCrescente(Vet, DimVet) ;
end;

procedure TForm1.BtnAccettaDimensioneClick(Sender: TObject);
begin
  AccettaDimensione(Vet, DimVet) ;
end;

procedure TForm1.BtnCancellazioneClick(Sender: TObject);
Var ValoreDaCancellare : Integer ; Verifica : Boolean ;
begin
  ValoreDaCancellare := StrToInt(Inputbox('','Inserisci valore da cancellare','')) ;
  Cancellazione(Vet, DimVet, ValoreDaCancellare, Verifica) ;
  If Verifica
    then ListBox5.Items.Add(IntTostr(ValoreDaCancellare) + ' è stato cancellato')
    else ListBox5.Items.Add(IntTostr(ValoreDaCancellare) + ' non è stato cancellato') ;
end;

procedure TForm1.BtnCreaConDatiRandomClick(Sender: TObject);
begin
  CreaConDatiRandom(Vet, DimVet) ;
end;

procedure TForm1.BtnCreaConDatiUtenteClick(Sender: TObject);
begin
  CreaConDatiUtente(Vet, DimVet) ;
end;

procedure TForm1.BtnCreaOrdinatoClick(Sender: TObject);
begin
  CreaOrdinato(Vet, DimVet) ;
end;

procedure TForm1.BtnDisordinaClick(Sender: TObject);
begin
  Disordina(Vet, DimVet) ;
end;

procedure TForm1.FormCreate(Sender: TObject);
Var i : Integer ;
begin
  Randomize ;
  For i := 1 To MaxComp do
    if i <= 9 then ListBox4.Items.Add('  ' + IntToStr(i) + '°')
    else ListBox4.Items.Add(IntToStr(i) + '°') ;
  ListaStampa := 1 ;
end;

procedure TForm1.RadioButton1Change(Sender: TObject);
begin
  ListaStampa := 1 ;
end;

procedure TForm1.RadioButton2Change(Sender: TObject);
begin
    ListaStampa := 2 ;
end;

procedure TForm1.RadioButton3Change(Sender: TObject);
begin
    ListaStampa := 3 ;
end;

procedure TForm1.BtnPulisciClick(Sender: TObject);
begin
  ListBox1.Clear ;  ListBox2.Clear ;  ListBox3.Clear ;    ListBox5.Clear ;
end;

end.

(*

procedure TForm1.Button1Click(Sender: TObject);
var Vet1,Vet2 : TVet ;   DimVet1,DimVet2 : Integer ;
begin
  Inizializza(Vet1, DimVet1) ;
  Inizializza(Vet2, DimVet2) ;
  AccettaDimensione(Vet1, DimVet1) ;
  AccettaDimensione(Vet2, DimVet2) ;
  CreaConDatiRandom(Vet1, DimVet1) ;
  CreaConDatiRandom(Vet2, DimVet2) ;
  Stampa(Vet1, DimVet1, 1) ;
  Stampa(Vet2, DimVet2, 2) ;
end;

*)

